package Controller;

import HibernateEntities.ClientsEntity;
import HibernateEntities.ModeratorsEntity;
import HibernateEntities.ProjectsEntity;
import ServiceEntites.AddInvite;
import ServiceEntites.AddProject;
import ServiceEntites.LoginUser;
import ServiceEntites.RegUser;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import static DAOImplement.AdminDao.getAdminById;
import static DAOImplement.AdminDao.getAdminByName;
import static DAOImplement.AdminDao.getAdminList;
import static DAOImplement.ClientsDao.checkIsClient;
import static DAOImplement.ClientsDao.createNewClient;
import static DAOImplement.ClientsDao.getClientProject;
import static DAOImplement.ProjectDao.createNewProject;
import static DAOImplement.ProjectDao.getProjectById;
import static DAOImplement.ProjectDao.updateProject;
import static DAOImplement.UsersDao.getUserNameList;

/**
 * Created by postgres on 03.04.2017.
 */
@Controller
@SessionAttributes("Client")
public class ProjectMovController {

    ModelAndView mvCrProject =new ModelAndView("CreateProjectViews/CrProject");
    ModelAndView mvProject =new ModelAndView("CreateProjectViews/Projects");
    ModelAndView mvInvite = new ModelAndView("CreateProjectViews/Invite");
    @RequestMapping(value="/goToProjectAppender")
    public ModelAndView regProjectLink(){
        ModelAndView mvCrProject =new ModelAndView("CreateProjectViews/CrProject");
        mvCrProject.addObject("Adder", new AddProject());
        return mvCrProject;
    }
    @RequestMapping(value="/CreateProject")
    public ModelAndView regNewProject(@ModelAttribute("Adder") AddProject addProject,
                                      @ModelAttribute("Client") ClientsEntity client){
        mvCrProject = new ModelAndView("CreateProjectViews/CrProject");
        boolean errors = false;
        try {
            if (addProject.getCltitle().trim().equals("")) {
                mvCrProject.addObject("Tittle", "Это поле обязательно для заполнения");
                errors = true;
            }
            if (addProject.getCldescription().trim().equals("")) {
                mvCrProject.addObject("Description", "Это поле обязательно для заполнения");
                errors = true;
            }

            if (addProject.getClstatus().trim().equals("")) {
                mvCrProject.addObject("Status", "Это поле обязательно для заполнения");
                errors = true;
            }
            if (addProject.getCldateOfReady().equals("")) {
                mvCrProject.addObject("DateOfReady", "Это поле обязательно для заполнения");
                errors = true;
            }
            if (addProject.getClsum().equals("")) {
                mvCrProject.addObject("Sum", "Это поле обязательно для заполнения");
                errors = true;
            }
            if (addProject.getCldateOfCreation().equals("")) {
                mvCrProject.addObject("DateOfCreation", "Это поле обязательно для заполнения");
                errors = true;
            }
            if (addProject.getCldateOfReady().equals("")) {
                mvCrProject.addObject("DateOfReady", "Это поле обязательно для заполнения");
                errors = true;
            }
            if (errors) {
                return mvCrProject;
            } else {
                ProjectsEntity projectsEntity = new ProjectsEntity();
                projectsEntity.setTitle(addProject.getCltitle().trim());
                projectsEntity.setDescription(addProject.getCldescription().trim());
                projectsEntity.setClId(client.getClientId());
                projectsEntity.setStatus(addProject.getClstatus().trim());
                projectsEntity.setDateOfCreation(addProject.getCldateOfCreation());
                projectsEntity.setDateOfReady(addProject.getCldateOfReady());
                projectsEntity.setSum(addProject.getClsum());
                    createNewProject(projectsEntity);
                    return new ModelAndView("redirect:/PCabinClient");
                }
        } catch (Exception ex) {
            ModelAndView errorView = new ModelAndView("otherViews/errorView");
            errorView.addObject("message", ex.toString());
            return errorView;
        }
    }
    @RequestMapping(value = "/goToProject")
    public ModelAndView clientChangeProjectData(@ModelAttribute("Client") ClientsEntity client,
                                                @RequestParam String prId) {
        try {
            ModelAndView clientchprdata = new ModelAndView("CreateProjectViews/Projects");
            ProjectsEntity project = getProjectById(Integer.parseInt(prId));
            AddProject addInfo = new AddProject(project);
            clientchprdata.addObject("addInfo", new AddProject());
            clientchprdata.addObject("Project", project);
            return clientchprdata;
        } catch (Exception ex) {
            return new ModelAndView("otherViews/errorView");
        }
    }

    @RequestMapping(value = "/loadModer", method = RequestMethod.GET)
    @ResponseBody
    public ModeratorsEntity loadModer(@RequestParam(value = "moderName", required = true) String moderName) throws IllegalStateException {
        try {

            ModeratorsEntity moder = getAdminByName(moderName);
            return moder;
        } catch (Exception ex) {
            return null;
        }
    }

    @RequestMapping(value = "/addInformProjectNew")
    public ModelAndView updateClientInformation(@ModelAttribute("addInfo") AddProject addInf,
                                                @RequestParam String prId) {
        try {
            ProjectsEntity projectsEntity = getProjectById(Integer.parseInt(prId));
            projectsEntity.setTitle(addInf.getCltitle().trim());
            projectsEntity.setDescription(addInf.getCldescription().trim());
            projectsEntity.setDateOfCreation(addInf.getCldateOfCreation());
            projectsEntity.setStatus(addInf.getClstatus().trim());
            projectsEntity.setSum(addInf.getClsum());
            projectsEntity.setDateOfReady(addInf.getCldateOfReady());
            updateProject(projectsEntity);
            return new ModelAndView("redirect:/PCabinClient");
        } catch (Exception ex) {
            return new ModelAndView("otherViews/errorView");
        }
    }

    @RequestMapping(value = "/goToInvite")

    public ModelAndView InvitePriglashenieGenerator(@ModelAttribute("Admin") ModeratorsEntity admin) {
        try {
            ModelAndView mvInvite= new ModelAndView("CreateProjectViews/Invite");
            mvInvite.addObject("adminList", getAdminList());
            return mvInvite;
        } catch (Exception ex) {
            return new ModelAndView("otherViews/errorView");
        }
    }

    }


