package DAOImplement;

import HibernateEntities.ClientsEntity;
import HibernateEntities.ModeratorsEntity;
import HibernateEntities.ProjectsEntity;
import com.sun.org.apache.xpath.internal.operations.Mod;
import org.hibernate.Session;
import org.hibernate.query.Query;

import javax.jws.WebParam;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import static HibernateUtil.HibernateUtil.getSession;

/**
 * Created by Кинетик on 31.12.2016.
 */
public class AdminDao {
    public static HashMap<String, ModeratorsEntity> getAdminMap(){
        Session session = getSession();
        Query query = session.createQuery("FROM ModeratorsEntity ");
        List<ModeratorsEntity> res = query.list();
        HashMap<String, ModeratorsEntity> adminsDict = new HashMap<>();
        for(ModeratorsEntity ad: res){
            adminsDict.put(ad.getModFamily()+" "+ad.getModFirstName()+" "+ad.getModSecName(),ad);
        }
        session.close();
        return adminsDict;
    }
    public static ArrayList<String> getAdminList(){
        Session session = getSession();
        Query query = session.createQuery("FROM ModeratorsEntity ");
        List<ModeratorsEntity> res = query.list();
        ArrayList<String> adminsList = new ArrayList<>();
        for(ModeratorsEntity ad: res){
            adminsList.add(ad.getModFamily()+" "+ad.getModFirstName()+" "+ad.getModSecName());
        }
        session.close();
        return adminsList;
    }
    public static void createNewAdmin(ModeratorsEntity admin) {
        Session session = getSession();
        Query query = session.createQuery("select max(modId) from ModeratorsEntity ");
        Integer res = (Integer) query.uniqueResult();
        admin.setModId(res+1);
        session.beginTransaction();
        session.save(admin);
        session.getTransaction().commit();
        session.close();
    }
    public static void updateAdmin (ModeratorsEntity admin) {
        Session session = getSession();
        session.beginTransaction();
        session.update(admin);
        session.getTransaction().commit();
        session.close();
    }
    public static List<ProjectsEntity> getAdminProject(ModeratorsEntity moderator) {
        Session session = getSession();
        Query query = session.createQuery("FROM ProjectsEntity Where modId = :mod_Id");
        query.setParameter("mod_Id", moderator.getModId());
        List<ProjectsEntity> res = query.list();
        session.close();
        return res;
    }
    public static boolean checkIsAdmin(ModeratorsEntity admin){
        Session session = getSession();
        Query query = session.createQuery("FROM ModeratorsEntity WHERE modFamily = :Family and modFirstName = :Name and modSecName = :SecondName");
        query.setParameter("Family", admin.getModFamily());
        query.setParameter("Name", admin.getModFirstName());
        query.setParameter("SecondName", admin.getModSecName());
        List<ModeratorsEntity> res = query.list();
        if(res.size()==0){
            return false;
        }
        return true;
    }

    public static ModeratorsEntity getAdminById(Integer adminId){
        Session session = getSession();
        ModeratorsEntity moderatorsEntity = (ModeratorsEntity) session.createQuery("from ModeratorsEntity where modId = :adminId")
                .setParameter("adminId", adminId).uniqueResult();
        session.close();
        return moderatorsEntity;
    }

    public static ModeratorsEntity getAdminByName(String adminName){
        Session session = getSession();
        List<ModeratorsEntity> moderatorsEntity = session.createQuery("from ModeratorsEntity where modFamily = :Family")
                .setParameter("Family", adminName.split(" ")[0]).list();
        session.close();
        return moderatorsEntity.get(0);
    }


}
