package DAOImplement;

import HibernateEntities.ClientsEntity;
import HibernateEntities.ProjectsEntity;
import HibernateUtil.HibernateUtil;
import org.hibernate.Session;
import org.hibernate.query.Query;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import static HibernateUtil.HibernateUtil.getSession;

/**
 * Created by postgres on 24.03.2017.
 */
public class ProjectDao {
    public static HashMap<String, ProjectsEntity> getProjectMap(){
        Session session = getSession();
        Query query = session.createQuery("FROM ProjectsEntity ");
        List<ProjectsEntity> res = query.list();
        HashMap<String,ProjectsEntity> projectsDict = new HashMap<>();
        for(ProjectsEntity cl: res){
            projectsDict.put(cl.getTitle()+" "+cl.getDescription()+" "+cl.getSum(),cl);
        }
        session.close();
        return projectsDict;
    }

    public static ProjectsEntity getProjectById(Integer prId){
        Session sesison = getSession();
        ProjectsEntity result = (ProjectsEntity) sesison.createQuery("From ProjectsEntity where prId = :prId")
                .setParameter("prId", prId).uniqueResult();
        sesison.close();
        return result;
    }

    public static ArrayList<String> getClientList(){
        Session session = getSession();
        Query query = session.createQuery("FROM ClientsEntity ");
        List<ClientsEntity> res = query.list();
        ArrayList<String> clientsList = new ArrayList<>();
        for(ClientsEntity cl: res){
            clientsList.add(cl.getClFamily()+" "+cl.getClFirstName()+" "+cl.getClSecName());
        }
        session.close();
        return clientsList;
    }
    public static  void createNewProject(ProjectsEntity projectsEntity){
        Session session = HibernateUtil.getSession();
        Query query = session.createQuery("Select max(prId) FROM ProjectsEntity");
        Integer res = (Integer)query.uniqueResult();
        projectsEntity.setPrId(res.intValue() + 1);
        session.beginTransaction();
        session.save(projectsEntity);
        session.getTransaction().commit();
        session.close();
    }
    public static void updateProject(ProjectsEntity projectsEntity) {
        Session session = getSession();
        session.beginTransaction();
        session.update(projectsEntity);
        session.getTransaction().commit();
        session.close();
    }
}
